PRO solar_c,ri,ro,N,filename

; FOR ARTIFICIALLY STABILIZED MODEL OF HANASOGE ET AL 2006
; NEEDS FAKE_ATM.pro and SOLAR_S 

; ri - interior radius
; ro - exterior radius
; N - number of points
; filename

 
G=6.672d-8

q = 14
rtemp = DBLARR(N)
N = N + q
data=DBLARR(25,2481)
openr,1,'solar_S'
readf,1,data
close,1
Rsol=6.959894677E+10
Msol=1.989000000E+33
data=REVERSE(data,2)
data[0,*]=data[0,*];*Rsol
ri=ri*Rsol
ro=ro*Rsol
sound_speed=DBLARR(2481)
;sound_speed[*]=SQRT(data[9,*]*data[3,*]/data[4,*])
fake_atm,rt,den,pre,gamma_n,gravity,sound_speed,temp
rt = rt*Rsol

;sound_speed = sound_speed^0.5
r=DBLARR(N)
derivs =  DBLARR(2481)
derivs = deriv(rt,sound_speed[*])
c=r

a=WHERE(ABS(rt-ri) EQ MIN(ABS(rt-ri)))
b=WHERE(ABS(rt-ro) EQ MIN(ABS(rt-ro)))

gizon=INT_TABULATED(rt[a[0]:b[0]],1.d0/sound_speed[a[0]:b[0]],/DOUBLE)/FLOAT(N)
r[0]=ri
c[0]=sound_speed[a[0]]
; Iteration 1
FOR i=1,N-1 DO BEGIN
r[i]=r[i-1]+ (EXP(derivs[a[0] + i]*gizon) - 1.0)*c[i-1]/derivs[a[0] + i]
c[i]=INTERPOL(sound_speed[*],rt,r[i],/LSQUADRATIC)
ENDFOR

derivs1 = DBLARR(N)
derivs1 = deriv(r,c)
; Second Iteration
FOR i=1,N-1 DO BEGIN
r[i]=r[i-1]+ (EXP(0.5*(derivs1[i] + derivs1[i-1])*gizon) - 1.0)*c[i-1]/(0.5*(derivs1[i]+derivs1[i-1]))
c[i]=INTERPOL(sound_speed[*],rt,r[i],/LSQUADRATIC)
ENDFOR


; Third Iteration
derivs2 = DBLARR(N)
derivs2 = deriv(r,c)
FOR i=1,N-1 DO BEGIN
r[i]=r[i-1]+ (EXP(0.5*(derivs2[i] + derivs2[i-1])*gizon) - 1.0)*c[i-1]/(0.5*(derivs2[i]+derivs2[i-1]))
c[i]=INTERPOL(sound_speed[*],rt,r[i],/LSQUADRATIC)
ENDFOR

r = r[q/2-1:N-q/2-2]
N = N-q
fake_atm,rt,den,pre,gamma_n,gravity_new,sound_speed,temper
rt = rt*Rsol

density=INTERPOL(den,rt,r,/LSQUADRATIC)
pressure=INTERPOL(pre,rt,r,/LSQUADRATIC)
gam=INTERPOL(gamma_n,rt,r,/LSQUADRATIC)
temperature=INTERPOL(temper,rt,r,/LSQUADRATIC)
;masse=INTERPOL(EXP(data[1,*]),rt,r,/LSQUADRATIC)*Msol
gravity=INTERPOL(gravity_new,rt,r,/LSQUADRATIC)


c=INTERPOL(sound_speed[*],rt,r,/LSQUADRATIC)
temp = ( ((2.0*!dPI*0.005)*r[*]/c[*])^2.0 +0.25)^0.5 - 0.5

time = DBLARR(N-1)
grid = DBLARR(N-1)
FOR I=0,N-2 DO BEGIN
  grid[I] = r[I+1] - r[I]
  time[I] = grid[I]/c[I]
ENDFOR

plot,r[0:N-2]/Rsol,grid[*]/Rsol,yst=1
print,'Timestep (approximately):', min(time)*1.9/1.64,' seconds'
print,max(time)*5.5*2.*!dPI*0.001

;read,pause
OPENW,1,filename
FOR i=0,N-1 DO BEGIN
PRINTF,1,r[i]/Rsol,c[i],density[i],pressure[i],temperature[i],gravity[i],gam[i],temp[i],format='(8E21.14)'
ENDFOR
CLOSE,1
read,pause


ENd
